;;; conf/client/rules.fnl --- Client placement rules

;;; Code:

(local awful (require :awful))
(local beautiful (require :beautiful))

(local keys (require :conf.client.keys))
(local buttons (require :conf.client.buttons))

;;;
;; Functions

(local
 rules
 [{:rule {}
   :properties {:border_width beautiful.border_width
                :border_color beautiful.border_normal
                :focus true
                :keys (. keys :client)
                :buttons buttons
                :size_hints_honor false ;; fuck you terminals I know what I want
                :placement awful.placement.no_offscreen}}

  {:rule {:floating true}
   :properties {:keys (. keys :floating)}}

  ;; Floating clients.
  {:rule_any {:class ["Gpick"
                      "Orage"]
              :name ["Event Tester"] ;; xev
              :role ["pop-up"
                     "xfce4-terminal-dropdown"]}
   :properties {:floating true}}

  ;; Add titlebars to normal clients and dialogs.
  {:rule_any {:type ["normal" "dialog"]}
   :properties {:titlebars_enabled true}}

  ;; Awesome reserves space for tint2, but doesn't actually fucking place it.
  {:rule {:class "Tint2"}
   :properties {:x 0 :y 0}}

  ;; Set Firefox to always map on the tag named "2" on screen 1.
  ;; {:rule {:class "Firefox"}
  ;;  :properties {:screen 1 :tag "2"}}
  ])

(tset awful.rules :rules rules)

{}
;;; conf/client/rules.fnl ends here
